/*!
FullCalendar Scheduler v5.7.2
Docs & License: https://fullcalendar.io/scheduler
(c) 2021 Adam Shaw
*/
var FullCalendarTimeline=function(e,t,n,r){"use strict";function i(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var o=i(n),a=function(e,t){return(a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)};function s(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}a(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var l=function(){return(l=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e}).apply(this,arguments)};t.config.MAX_TIMELINE_SLOTS=1e3;var c=[{years:1},{months:1},{days:1},{hours:1},{minutes:30},{minutes:15},{minutes:10},{minutes:5},{minutes:1},{seconds:30},{seconds:15},{seconds:10},{seconds:5},{seconds:1},{milliseconds:500},{milliseconds:100},{milliseconds:10},{milliseconds:1}];function u(e,n,r,i){var o={labelInterval:r.slotLabelInterval,slotDuration:r.slotDuration};!function(e,n,r){var i=n.currentRange;if(e.labelInterval){r.countDurationsBetween(i.start,i.end,e.labelInterval)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotLabelInterval results in too many cells"),e.labelInterval=null)}if(e.slotDuration){r.countDurationsBetween(i.start,i.end,e.slotDuration)>t.config.MAX_TIMELINE_SLOTS&&(console.warn("slotDuration results in too many cells"),e.slotDuration=null)}if(e.labelInterval&&e.slotDuration){var o=t.wholeDivideDurations(e.labelInterval,e.slotDuration);(null===o||o<1)&&(console.warn("slotLabelInterval must be a multiple of slotDuration"),e.slotDuration=null)}}(o,e,n),h(o,e,n),function(e,n,r){var i=n.currentRange,o=e.slotDuration;if(!o){for(var a=h(e,n,r),s=0,l=c;s<l.length;s++){var u=l[s],d=t.createDuration(u),f=t.wholeDivideDurations(a,d);if(null!==f&&f>1&&f<=6){o=d;break}}if(o)r.countDurationsBetween(i.start,i.end,o)>200&&(o=null);o||(o=a),e.slotDuration=o}}(o,e,n);var a=r.slotLabelFormat,s=Array.isArray(a)?a:null!=a?[a]:function(e,n,r,i){var o,a,s=e.labelInterval,l=t.greatestDurationDenominator(s).unit,c=i.weekNumbers,u=o=a=null;"week"!==l||c||(l="day");switch(l){case"year":u={year:"numeric"};break;case"month":m("years",n,r)>1&&(u={year:"numeric"}),o={month:"short"};break;case"week":m("years",n,r)>1&&(u={year:"numeric"}),o={week:"narrow"};break;case"day":m("years",n,r)>1?u={year:"numeric",month:"long"}:m("months",n,r)>1&&(u={month:"long"}),c&&(o={week:"short"}),a={weekday:"narrow",day:"numeric"};break;case"hour":c&&(u={week:"short"}),m("days",n,r)>1&&(o={weekday:"short",day:"numeric",month:"numeric",omitCommas:!0}),a={hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"short"};break;case"minute":t.asRoughMinutes(s)/60>=6?(u={hour:"numeric",meridiem:"short"},o=function(e){return":"+t.padStart(e.date.minute,2)}):u={hour:"numeric",minute:"numeric",meridiem:"short"};break;case"second":t.asRoughSeconds(s)/60>=6?(u={hour:"numeric",minute:"2-digit",meridiem:"lowercase"},o=function(e){return":"+t.padStart(e.date.second,2)}):u={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"};break;case"millisecond":u={hour:"numeric",minute:"2-digit",second:"2-digit",meridiem:"lowercase"},o=function(e){return"."+t.padStart(e.millisecond,3)}}return[].concat(u||[],o||[],a||[])}(o,e,n,r);o.headerFormats=s.map((function(e){return t.createFormatter(e)})),o.isTimeScale=Boolean(o.slotDuration.milliseconds);var l=null;if(!o.isTimeScale){var u=t.greatestDurationDenominator(o.slotDuration).unit;/year|month|week/.test(u)&&(l=u)}o.largeUnit=l,o.emphasizeWeeks=1===t.asCleanDays(o.slotDuration)&&m("weeks",e,n)>=2&&!r.businessHours;var g,v,y=r.snapDuration;y&&(g=t.createDuration(y),v=t.wholeDivideDurations(o.slotDuration,g)),null==v&&(g=o.slotDuration,v=1),o.snapDuration=g,o.snapsPerSlot=v;var D=t.asRoughMs(e.slotMaxTime)-t.asRoughMs(e.slotMinTime),S=d(e.renderRange.start,o,n),R=d(e.renderRange.end,o,n);o.isTimeScale&&(S=n.add(S,e.slotMinTime),R=n.add(t.addDays(R,-1),e.slotMaxTime)),o.timeWindowMs=D,o.normalizedRange={start:S,end:R};for(var C=[],E=S;E<R;)f(E,o,e,i)&&C.push(E),E=n.add(E,o.slotDuration);o.slotDates=C;var w=-1,b=0,k=[],P=[];for(E=S;E<R;)f(E,o,e,i)?(w+=1,k.push(w),P.push(b)):k.push(w+.5),E=n.add(E,o.snapDuration),b+=1;return o.snapDiffToIndex=k,o.snapIndexToDiff=P,o.snapCnt=w+1,o.slotCnt=o.snapCnt/o.snapsPerSlot,o.isWeekStarts=function(e,t){for(var n=e.slotDates,r=e.emphasizeWeeks,i=null,o=[],a=0,s=n;a<s.length;a++){var l=s[a],c=t.computeWeekNumber(l),u=r&&null!==i&&i!==c;i=c,o.push(u)}return o}(o,n),o.cellRows=function(e,n){for(var r=e.slotDates,i=e.headerFormats,o=i.map((function(){return[]})),a=t.asCleanDays(e.slotDuration),s=7===a?"week":1===a?"day":null,l=i.map((function(e){return e.getLargestUnit?e.getLargestUnit():null})),c=0;c<r.length;c+=1)for(var u=r[c],d=e.isWeekStarts[c],f=0;f<i.length;f+=1){var h=i[f],m=o[f],g=m[m.length-1],v=f===i.length-1,y=i.length>1&&!v,D=null,S=l[f]||(v?s:null);if(y){var R=n.format(u,h);g&&g.text===R?g.colspan+=1:D=p(u,R,S)}else if(!g||t.isInt(n.countDurationsBetween(e.normalizedRange.start,u,e.labelInterval))){D=p(u,R=n.format(u,h),S)}else g.colspan+=1;D&&(D.weekStart=d,m.push(D))}return o}(o,n),o.slotsPerLabel=t.wholeDivideDurations(o.labelInterval,o.slotDuration),o}function d(e,n,r){var i=e;return n.isTimeScale||(i=t.startOfDay(i),n.largeUnit&&(i=r.startOf(i,n.largeUnit))),i}function f(e,n,r,i){if(i.isHiddenDay(e))return!1;if(n.isTimeScale){var o=t.startOfDay(e),a=e.valueOf()-o.valueOf()-t.asRoughMs(r.slotMinTime);return(a=(a%864e5+864e5)%864e5)<n.timeWindowMs}return!0}function h(e,n,r){var i=n.currentRange,o=e.labelInterval;if(!o){var a=void 0;if(e.slotDuration){for(var s=0,l=c;s<l.length;s++){a=l[s];var u=t.createDuration(a),d=t.wholeDivideDurations(u,e.slotDuration);if(null!==d&&d<=6){o=u;break}}o||(o=e.slotDuration)}else for(var f=0,h=c;f<h.length;f++){if(a=h[f],o=t.createDuration(a),r.countDurationsBetween(i.start,i.end,o)>=18)break}e.labelInterval=o}return o}function m(e,n,r){var i=n.currentRange,o=null;return"years"===e?o=r.diffWholeYears(i.start,i.end):"months"===e||"weeks"===e?o=r.diffWholeMonths(i.start,i.end):"days"===e&&(o=t.diffWholeDays(i.start,i.end)),o||0}function p(e,t,n){return{date:e,text:t,rowUnit:n,colspan:1,isWeekStart:!1}}var g=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,r=e.navLinkData?{"data-navlink":e.navLinkData,tabIndex:0}:{};return t.createElement(t.ContentHook,{hookProps:e.hookProps,content:n.options.slotLabelContent,defaultContent:v},(function(n,i){return t.createElement("a",l({ref:n,className:"fc-timeline-slot-cushion fc-scrollgrid-sync-inner"+(e.isSticky?" fc-sticky":"")},r),i)}))},n}(t.BaseComponent);function v(e){return e.text}function y(e){return{level:e.level,date:e.dateEnv.toDate(e.dateMarker),view:e.viewApi,text:e.text}}var D=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.refineHookProps=t.memoizeObjArg(y),n.normalizeClassNames=t.buildClassNameNormalizer(),n}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,r=n.dateEnv,i=n.options,o=e.cell,a=e.dateProfile,s=e.tDateProfile,l=t.getDateMeta(o.date,e.todayRange,e.nowDate,a),c=["fc-timeline-slot","fc-timeline-slot-label"].concat("time"===o.rowUnit?t.getSlotClassNames(l,n.theme):t.getDayClassNames(l,n.theme));o.isWeekStart&&c.push("fc-timeline-slot-em");var u=i.navLinks&&o.rowUnit&&"time"!==o.rowUnit?t.buildNavLinkData(o.date,o.rowUnit):null,d=this.refineHookProps({level:e.rowLevel,dateMarker:o.date,text:o.text,dateEnv:n.dateEnv,viewApi:n.viewApi}),f=this.normalizeClassNames(i.slotLabelClassNames,d);return t.createElement(t.MountHook,{hookProps:d,didMount:i.slotLabelDidMount,willUnmount:i.slotLabelWillUnmount},(function(n){return t.createElement("th",{ref:n,className:c.concat(f).join(" "),"data-date":r.formatIso(o.date,{omitTime:!s.isTimeScale,omitTimeZoneOffset:!0}),colSpan:o.colspan},t.createElement("div",{className:"fc-timeline-slot-frame",style:{height:e.rowInnerHeight}},t.createElement(g,{hookProps:d,isSticky:e.isSticky,navLinkData:u})))}))},n}(t.BaseComponent),S=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=e.dateProfile,r=e.tDateProfile,i=e.rowInnerHeights,o=e.todayRange,a=e.nowDate,s=r.cellRows;return t.createElement(t.Fragment,null,s.map((function(e,l){var c=l===s.length-1,u=["fc-timeline-header-row",r.isTimeScale&&c?"fc-timeline-header-row-chrono":""];return t.createElement("tr",{key:l,className:u.join(" ")},e.map((function(e){return t.createElement(D,{key:e.date.toISOString(),cell:e,rowLevel:l,dateProfile:n,tDateProfile:r,todayRange:o,nowDate:a,rowInnerHeight:i&&i[l],isSticky:!c})})))})))},n}(t.BaseComponent),R=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,r=this.context,i=t.greatestDurationDenominator(n.tDateProfile.slotDuration).unit,o=n.slatCoords&&n.slatCoords.dateProfile===n.dateProfile?n.slatCoords:null;return t.createElement(t.NowTimer,{unit:i},(function(i,a){return t.createElement("div",{className:"fc-timeline-header",ref:e.rootElRef},t.createElement("table",{className:"fc-scrollgrid-sync-table",style:{minWidth:n.tableMinWidth,width:n.clientWidth}},n.tableColGroupNode,t.createElement("tbody",null,t.createElement(S,{dateProfile:n.dateProfile,tDateProfile:n.tDateProfile,nowDate:i,todayRange:a,rowInnerHeights:n.rowInnerHeights}))),r.options.nowIndicator&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},o&&o.isDateInRange(i)&&t.createElement(t.NowIndicatorRoot,{isAxis:!0,date:i},(function(e,n,r,a){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-arrow"].concat(n).join(" "),style:{left:o.dateToCoord(i)}},a)}))))}))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(){this.updateSize()},n.prototype.updateSize=function(){this.props.onMaxCushionWidth&&this.props.onMaxCushionWidth(this.computeMaxCushionWidth())},n.prototype.computeMaxCushionWidth=function(){return Math.max.apply(Math,t.findElements(this.rootElRef.current,".fc-timeline-header-row:last-child .fc-timeline-slot-cushion").map((function(e){return e.getBoundingClientRect().width})))},n}(t.BaseComponent),C=function(){function e(e,n,r,i,o,a){this.slatRootEl=e,this.dateProfile=r,this.tDateProfile=i,this.dateEnv=o,this.isRtl=a,this.outerCoordCache=new t.PositionCache(e,n,!0,!1),this.innerCoordCache=new t.PositionCache(e,t.findDirectChildren(n,"div"),!0,!1)}return e.prototype.rangeToCoords=function(e){return this.isRtl?{right:this.dateToCoord(e.start),left:this.dateToCoord(e.end)}:{left:this.dateToCoord(e.start),right:this.dateToCoord(e.end)}},e.prototype.isDateInRange=function(e){return t.rangeContainsMarker(this.dateProfile.currentRange,e)},e.prototype.dateToCoord=function(e){var t=this.tDateProfile,n=this.computeDateSnapCoverage(e)/t.snapsPerSlot,r=Math.floor(n),i=n-(r=Math.min(r,t.slotCnt-1)),o=this.innerCoordCache,a=this.outerCoordCache;return this.isRtl?a.rights[r]-o.getWidth(r)*i-a.originClientRect.width:a.lefts[r]+o.getWidth(r)*i},e.prototype.computeDateSnapCoverage=function(e){return E(e,this.tDateProfile,this.dateEnv)},e.prototype.computeDurationLeft=function(e){var n=this,r=n.dateProfile,i=n.tDateProfile,o=n.dateEnv,a=n.isRtl,s=0;if(r){var l=o.add(r.activeRange.start,e);i.isTimeScale||(l=t.startOfDay(l)),s=this.dateToCoord(l),!a&&s&&(s+=1)}return s},e}();function E(e,n,r){var i=r.countDurationsBetween(n.normalizedRange.start,e,n.snapDuration);if(i<0)return 0;if(i>=n.snapDiffToIndex.length)return n.snapCnt;var o=Math.floor(i),a=n.snapDiffToIndex[o];return t.isInt(a)?a+=i-o:a=Math.ceil(a),a}var w=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context,r=n.dateEnv,i=n.options,o=n.theme,a=e.date,s=e.tDateProfile,c=e.isEm,u=t.getDateMeta(e.date,e.todayRange,e.nowDate,e.dateProfile),d=["fc-timeline-slot","fc-timeline-slot-lane"],f={"data-date":r.formatIso(a,{omitTimeZoneOffset:!0,omitTime:!s.isTimeScale})},h=l(l({date:r.toDate(e.date)},u),{view:n.viewApi});return c&&d.push("fc-timeline-slot-em"),s.isTimeScale&&d.push(t.isInt(r.countDurationsBetween(s.normalizedRange.start,e.date,s.labelInterval))?"fc-timeline-slot-major":"fc-timeline-slot-minor"),d.push.apply(d,e.isDay?t.getDayClassNames(u,o):t.getSlotClassNames(u,o)),t.createElement(t.RenderHook,{hookProps:h,classNames:i.slotLaneClassNames,content:i.slotLaneContent,didMount:i.slotLaneDidMount,willUnmount:i.slotLaneWillUnmount,elRef:e.elRef},(function(e,n,r,i){return t.createElement("td",l({ref:e,className:d.concat(n).join(" ")},f),t.createElement("div",{ref:r},i))}))},n}(t.BaseComponent),b=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=e.tDateProfile,r=e.cellElRefs,i=n.slotDates,o=n.isWeekStarts,a=!n.isTimeScale&&!n.largeUnit;return t.createElement("tbody",null,t.createElement("tr",null,i.map((function(i,s){var l=i.toISOString();return t.createElement(w,{key:l,elRef:r.createRef(l),date:i,dateProfile:e.dateProfile,tDateProfile:n,nowDate:e.nowDate,todayRange:e.todayRange,isEm:o[s],isDay:a})}))))},n}(t.BaseComponent),k=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n.cellElRefs=new t.RefMap,n.handleScrollRequest=function(e){var t=n.props.onScrollLeftRequest,r=n.coords;if(t&&r){if(e.time)t(r.computeDurationLeft(e.time));return!0}return null},n}return s(n,e),n.prototype.render=function(){var e=this.props,n=this.context;return t.createElement("div",{className:"fc-timeline-slots",ref:this.rootElRef},t.createElement("table",{className:n.theme.getClass("table"),style:{minWidth:e.tableMinWidth,width:e.clientWidth}},e.tableColGroupNode,t.createElement(b,{cellElRefs:this.cellElRefs,dateProfile:e.dateProfile,tDateProfile:e.tDateProfile,nowDate:e.nowDate,todayRange:e.todayRange})))},n.prototype.componentDidMount=function(){this.updateSizing(),this.scrollResponder=this.context.createScrollResponder(this.handleScrollRequest)},n.prototype.componentDidUpdate=function(e){this.updateSizing(),this.scrollResponder.update(e.dateProfile!==this.props.dateProfile)},n.prototype.componentWillUnmount=function(){this.scrollResponder.detach(),this.props.onCoords&&this.props.onCoords(null)},n.prototype.updateSizing=function(){var e,t=this.props,n=this.context;null!==t.clientWidth&&this.scrollResponder&&(this.rootElRef.current.offsetWidth&&(this.coords=new C(this.rootElRef.current,(e=this.cellElRefs.currentMap,t.tDateProfile.slotDates.map((function(t){var n=t.toISOString();return e[n]}))),t.dateProfile,t.tDateProfile,n.dateEnv,n.isRtl),t.onCoords&&t.onCoords(this.coords),this.scrollResponder.update(!1)))},n.prototype.positionToHit=function(e){var n=this.coords.outerCoordCache,r=this.context,i=r.dateEnv,o=r.isRtl,a=this.props.tDateProfile,s=n.leftToIndex(e);if(null!=s){var l=n.getWidth(s),c=o?(n.rights[s]-e)/l:(e-n.lefts[s])/l,u=Math.floor(c*a.snapsPerSlot),d=i.add(a.slotDates[s],t.multiplyDuration(a.snapDuration,u));return{dateSpan:{range:{start:d,end:i.add(d,a.snapDuration)},allDay:!this.props.tDateProfile.isTimeScale},dayEl:this.cellElRefs.currentMap[s],left:n.lefts[s],right:n.rights[s]}}return null},n}(t.BaseComponent);var P=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props,n=[].concat(e.eventResizeSegs,e.dateSelectionSegs);return e.timelineCoords&&t.createElement("div",{className:"fc-timeline-bg"},this.renderSegs(e.businessHourSegs||[],e.timelineCoords,"non-business"),this.renderSegs(e.bgEventSegs||[],e.timelineCoords,"bg-event"),this.renderSegs(n,e.timelineCoords,"highlight"))},n.prototype.renderSegs=function(e,n,r){var i=this.props,o=i.todayRange,a=i.nowDate,s=e.map((function(e){var i=n.rangeToCoords(e);return t.createElement("div",{key:t.buildEventRangeKey(e.eventRange),className:"fc-timeline-bg-harness",style:{left:i.left,right:-i.right}},"bg-event"===r?t.createElement(t.BgEvent,l({seg:e},t.getSegMeta(e,o,a))):t.renderFill(r))}));return t.createElement(t.Fragment,null,s)},n}(t.BaseComponent),M=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.sliceRange=function(e,n,r,i,o){var a=function(e,n,r){if(!n.isTimeScale&&(e=t.computeVisibleDayRange(e),n.largeUnit)){var i=e;((e={start:r.startOf(e.start,n.largeUnit),end:r.startOf(e.end,n.largeUnit)}).end.valueOf()!==i.end.valueOf()||e.end<=e.start)&&(e={start:e.start,end:r.add(e.end,n.slotDuration)})}return e}(e,i,o),s=[];if(E(a.start,i,o)<E(a.end,i,o)){var l=t.intersectRanges(a,i.normalizedRange);l&&s.push({start:l.start,end:l.end,isStart:l.start.valueOf()===a.start.valueOf()&&f(l.start,i,n,r),isEnd:l.end.valueOf()===a.end.valueOf()&&f(t.addMs(l.end,-1),i,n,r)})}return s},n}(t.Slicer),T=t.createFormatter({hour:"numeric",minute:"2-digit",omitZeroMinute:!0,meridiem:"narrow"}),I=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return s(n,e),n.prototype.render=function(){var e=this.props;return t.createElement(t.StandardEvent,l({},e,{extraClassNames:["fc-timeline-event","fc-h-event"],defaultTimeFormat:T,defaultDisplayEventTime:!e.isTimeScale}))},n}(t.BaseComponent),W=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.rootElRef=t.createRef(),n}return s(n,e),n.prototype.render=function(){var e=this,n=this.props,r=n.hiddenSegs,i=n.elRef,o=n.placement,a=n.resourceId,s=a?{resourceId:a}:{};return t.createElement(t.MoreLinkRoot,{allDayDate:null,moreCnt:r.length,allSegs:r,hiddenSegs:r,alignmentElRef:this.rootElRef,dateProfile:n.dateProfile,todayRange:n.todayRange,extraDateSpan:s,popoverContent:function(){return t.createElement(t.Fragment,null,r.map((function(e){var r=e.eventRange.instance.instanceId;return t.createElement("div",{key:r,style:{visibility:n.isForcedInvisible[r]?"hidden":""}},t.createElement(I,l({isTimeScale:n.isTimeScale,seg:e,isDragging:!1,isResizing:!1,isDateSelecting:!1,isSelected:r===n.eventSelection},t.getSegMeta(e,n.todayRange,n.nowDate))))})))}},(function(n,r,a,s,l){return t.createElement("a",{ref:function(r){t.setRef(n,r),t.setRef(i,r),t.setRef(e.rootElRef,r)},className:["fc-timeline-more-link"].concat(r).join(" "),style:{left:o.left,right:-o.right,top:o.top,visibility:o.isVisible?"":"hidden"},onClick:l},t.createElement("div",{ref:a,className:"fc-timeline-more-link-inner fc-sticky"},s))}))},n}(t.BaseComponent);function x(e,n,r,i,o,a,s,l){var c=[],u=[];if(n)for(var d=0;d<e.length;d+=1){var f=e[d],h=r[f.eventRange.instance.instanceId],m=n.rangeToCoords(f),p=Math.round(m.left),g=Math.round(m.right);g-p<o&&(a?p=g-o:g=p+o),null!=h?c.push({index:d,spanStart:p,spanEnd:g,thickness:h}):u.push({seg:f,isVisible:!1,left:p,right:g,top:0})}var v=new t.SegHierarchy;null!=s&&(v.strictOrder=s),null!=l&&(v.maxStackCnt=l);var y=v.addSegs(c),D=y.map((function(t){return{seg:e[t.segInput.index],isVisible:!1,left:t.spanStart,right:t.spanEnd,top:0}})),S=t.groupIntersectingEntries(y),R=[],C=[],E=function(t){return e[t.segInput.index]};for(d=0;d<S.length;d+=1){var w=S[d],b=w.entries.map(E);null!=(h=i[t.buildIsoString(t.computeEarliestSegStart(b))])?R.push({index:e.length+d,spanStart:w.spanStart,spanEnd:w.spanEnd,thickness:h}):C.push({seg:b,isVisible:!1,left:w.spanStart,right:w.spanEnd,top:0})}v.maxStackCnt=-1,v.addSegs(R);for(var k=[],P=0,M=0,T=v.toRects();M<T.length;M++){var I=T[M],W=I.segInput.index;k.push({seg:W<e.length?e[W]:S[W-e.length].entries.map(E),isVisible:!0,left:I.spanStart,right:I.spanEnd,top:I.levelCoord}),P=Math.max(P,I.levelCoord+I.thickness)}return[k.concat(u,D,C),P]}var N=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slicer=new M,n.sortEventSegs=t.memoize(t.sortEventSegs),n.computeFgSegPlacements=t.memoize(x),n.harnessElRefs=new t.RefMap,n.moreElRefs=new t.RefMap,n.innerElRef=t.createRef(),n.state={eventInstanceHeights:{},moreLinkHeights:{}},n}return s(n,e),n.prototype.render=function(){var e=this,n=e.props,r=e.state,i=e.context,o=i.options,a=n.dateProfile,s=n.tDateProfile,l=this.slicer.sliceProps(n,a,s.isTimeScale?null:n.nextDayThreshold,i,a,i.dateProfileGenerator,s,i.dateEnv),c=(l.eventDrag?l.eventDrag.segs:null)||(l.eventResize?l.eventResize.segs:null)||[],u=this.sortEventSegs(l.fgEventSegs,o.eventOrder),d=this.computeFgSegPlacements(u,n.timelineCoords,r.eventInstanceHeights,r.moreLinkHeights,o.eventMinWidth,i.isRtl,o.eventOrderStrict,o.eventMaxStack),f=d[0],h=d[1],m=(l.eventDrag?l.eventDrag.affectedInstances:null)||(l.eventResize?l.eventResize.affectedInstances:null)||{};return t.createElement(t.Fragment,null,t.createElement(P,{businessHourSegs:l.businessHourSegs,bgEventSegs:l.bgEventSegs,timelineCoords:n.timelineCoords,eventResizeSegs:l.eventResize?l.eventResize.segs:[],dateSelectionSegs:l.dateSelectionSegs,nowDate:n.nowDate,todayRange:n.todayRange}),t.createElement("div",{className:"fc-timeline-events fc-scrollgrid-sync-inner",ref:this.innerElRef,style:{height:h}},this.renderFgSegs(f,m),this.renderFgSegs(function(e,t,n){if(!e.length||!t)return[];var r=function(e){for(var t={},n=0,r=e;n<r.length;n++){var i=r[n],o=i.seg;Array.isArray(o)||(t[o.eventRange.instance.instanceId]=i.top)}return t}(n);return e.map((function(e){var n=t.rangeToCoords(e);return{seg:e,isVisible:!0,left:n.left,right:n.right,top:r[e.eventRange.instance.instanceId]}}))}(c,n.timelineCoords,f),{},Boolean(l.eventDrag),Boolean(l.eventResize),!1)))},n.prototype.componentDidMount=function(){this.updateSize()},n.prototype.componentDidUpdate=function(e,t){e.eventStore===this.props.eventStore&&e.timelineCoords===this.props.timelineCoords&&t.moreLinkHeights===this.state.moreLinkHeights||this.updateSize()},n.prototype.updateSize=function(){var e=this,n=this.props,r=n.timelineCoords;n.onHeightChange&&n.onHeightChange(this.innerElRef.current,!1),r&&this.setState({eventInstanceHeights:t.mapHash(this.harnessElRefs.currentMap,(function(e){return Math.round(e.getBoundingClientRect().height)})),moreLinkHeights:t.mapHash(this.moreElRefs.currentMap,(function(e){return Math.round(e.getBoundingClientRect().height)}))},(function(){n.onHeightChange&&n.onHeightChange(e.innerElRef.current,!0)}))},n.prototype.renderFgSegs=function(e,n,r,i,o){var a=this,s=a.harnessElRefs,c=a.moreElRefs,u=a.props,d=r||i||o;return t.createElement(t.Fragment,null,e.map((function(e){var a=e.seg;if(Array.isArray(a)){var f=t.buildIsoString(t.computeEarliestSegStart(a));return t.createElement(W,{key:"m:"+f,elRef:c.createRef(f),hiddenSegs:a,placement:e,dateProfile:u.dateProfile,nowDate:u.nowDate,todayRange:u.todayRange,isTimeScale:u.tDateProfile.isTimeScale,eventSelection:u.eventSelection,resourceId:u.resourceId,isForcedInvisible:n})}var h=a.eventRange.instance.instanceId,m=e.isVisible&&!n[h];return t.createElement("div",{key:"e:"+h,ref:d?null:s.createRef(h),className:"fc-timeline-event-harness",style:{left:e.left,right:-e.right,top:e.top,visibility:m?"":"hidden"}},t.createElement(I,l({isTimeScale:u.tDateProfile.isTimeScale,seg:a,isDragging:r,isResizing:i,isDateSelecting:o,isSelected:h===u.eventSelection},t.getSegMeta(a,u.todayRange,u.nowDate))))})))},n}(t.BaseComponent);N.addStateEquality({eventInstanceHeights:t.isPropsEqual,moreLinkHeights:t.isPropsEqual});var L=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.slatsRef=t.createRef(),n.state={coords:null},n.handeEl=function(e){e?n.context.registerInteractiveComponent(n,{el:e}):n.context.unregisterInteractiveComponent(n)},n.handleCoords=function(e){n.setState({coords:e}),n.props.onSlatCoords&&n.props.onSlatCoords(e)},n}return s(n,e),n.prototype.render=function(){var e=this,n=this,r=n.props,i=n.state,o=n.context.options,a=r.dateProfile,s=r.tDateProfile,l=t.greatestDurationDenominator(s.slotDuration).unit;return t.createElement("div",{className:"fc-timeline-body",ref:this.handeEl,style:{minWidth:r.tableMinWidth,height:r.clientHeight,width:r.clientWidth}},t.createElement(t.NowTimer,{unit:l},(function(n,l){return t.createElement(t.Fragment,null,t.createElement(k,{ref:e.slatsRef,dateProfile:a,tDateProfile:s,nowDate:n,todayRange:l,clientWidth:r.clientWidth,tableColGroupNode:r.tableColGroupNode,tableMinWidth:r.tableMinWidth,onCoords:e.handleCoords,onScrollLeftRequest:r.onScrollLeftRequest}),t.createElement(N,{dateProfile:a,tDateProfile:r.tDateProfile,nowDate:n,todayRange:l,nextDayThreshold:o.nextDayThreshold,businessHours:r.businessHours,eventStore:r.eventStore,eventUiBases:r.eventUiBases,dateSelection:r.dateSelection,eventSelection:r.eventSelection,eventDrag:r.eventDrag,eventResize:r.eventResize,timelineCoords:i.coords}),o.nowIndicator&&i.coords&&i.coords.isDateInRange(n)&&t.createElement("div",{className:"fc-timeline-now-indicator-container"},t.createElement(t.NowIndicatorRoot,{isAxis:!1,date:n},(function(e,r,o,a){return t.createElement("div",{ref:e,className:["fc-timeline-now-indicator-line"].concat(r).join(" "),style:{left:i.coords.dateToCoord(n)}},a)}))))})))},n.prototype.queryHit=function(e,t,n,r){var i=this.slatsRef.current.positionToHit(e);return i?{dateProfile:this.props.dateProfile,dateSpan:i.dateSpan,rect:{left:i.left,right:i.right,top:0,bottom:r},dayEl:i.dayEl,layer:0}:null},n}(t.DateComponent),H=function(e){function n(){var n=null!==e&&e.apply(this,arguments)||this;return n.buildTimelineDateProfile=t.memoize(u),n.scrollGridRef=t.createRef(),n.state={slatCoords:null,slotCushionMaxWidth:null},n.handleSlatCoords=function(e){n.setState({slatCoords:e})},n.handleScrollLeftRequest=function(e){n.scrollGridRef.current.forceScrollLeft(0,e)},n.handleMaxCushionWidth=function(e){n.setState({slotCushionMaxWidth:Math.ceil(e)})},n}return s(n,e),n.prototype.render=function(){var e=this,n=this,i=n.props,o=n.state,a=n.context,s=a.options,c=!i.forPrint&&t.getStickyHeaderDates(s),u=!i.forPrint&&t.getStickyFooterScrollbar(s),d=this.buildTimelineDateProfile(i.dateProfile,a.dateEnv,s,a.dateProfileGenerator),f=["fc-timeline",!1===s.eventOverlap?"fc-timeline-overlap-disabled":""],h=s.slotMinWidth,m=z(d,h||this.computeFallbackSlotMinWidth(d)),p=[{type:"header",key:"header",isSticky:c,chunks:[{key:"timeline",content:function(n){return t.createElement(R,{dateProfile:i.dateProfile,clientWidth:n.clientWidth,clientHeight:n.clientHeight,tableMinWidth:n.tableMinWidth,tableColGroupNode:n.tableColGroupNode,tDateProfile:d,slatCoords:o.slatCoords,onMaxCushionWidth:h?null:e.handleMaxCushionWidth})}}]},{type:"body",key:"body",liquid:!0,chunks:[{key:"timeline",content:function(n){return t.createElement(L,l({},i,{clientWidth:n.clientWidth,clientHeight:n.clientHeight,tableMinWidth:n.tableMinWidth,tableColGroupNode:n.tableColGroupNode,tDateProfile:d,onSlatCoords:e.handleSlatCoords,onScrollLeftRequest:e.handleScrollLeftRequest}))}}]}];return u&&p.push({type:"footer",key:"footer",isSticky:!0,chunks:[{key:"timeline",content:t.renderScrollShim}]}),t.createElement(t.ViewRoot,{viewSpec:a.viewSpec},(function(n,o){return t.createElement("div",{ref:n,className:f.concat(o).join(" ")},t.createElement(r.ScrollGrid,{ref:e.scrollGridRef,liquid:!i.isHeightAuto&&!i.forPrint,collapsibleWidth:!1,colGroups:[{cols:m}],sections:p}))}))},n.prototype.computeFallbackSlotMinWidth=function(e){return Math.max(30,(this.state.slotCushionMaxWidth||0)/e.slotsPerLabel)},n}(t.DateComponent);function z(e,t){return[{span:e.slotCnt,minWidth:t||1}]}var O=t.createPlugin({deps:[o.default],initialView:"timelineDay",views:{timeline:{component:H,usesMinMaxTime:!0,eventResizableFromStart:!0},timelineDay:{type:"timeline",duration:{days:1}},timelineWeek:{type:"timeline",duration:{weeks:1}},timelineMonth:{type:"timeline",duration:{months:1}},timelineYear:{type:"timeline",duration:{years:1}}}});return t.globalPlugins.push(O),e.TimelineCoords=C,e.TimelineHeader=R,e.TimelineHeaderRows=S,e.TimelineLane=N,e.TimelineLaneBg=P,e.TimelineLaneSlicer=M,e.TimelineSlats=k,e.TimelineView=H,e.buildSlatCols=z,e.buildTimelineDateProfile=u,e.default=O,Object.defineProperty(e,"__esModule",{value:!0}),e}({},FullCalendar,FullCalendarPremiumCommon,FullCalendarScrollGrid);